package com.bzd.web.controller.xsgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.xsgl.SXsglMdlsrbbYgSalesperformanceinfoService;

import java.util.List;

/**
*
* 零售员工日报表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "xsgl/sxsglmdlsrbbygsalesperformanceinfo")
public class SXsglMdlsrbbYgSalesperformanceinfoController extends BaseController {

    // 页面跳转前缀
    private String prefix = "xsgl";

    @Autowired
    private SXsglMdlsrbbYgSalesperformanceinfoService sXsglMdlsrbbYgSalesperformanceinfoService;

    /**
    * 零售员工日报表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("xsgl:xs:view")
    @GetMapping("/sXsglMdlsrbbYgSalesperformanceinfoAdd")
    public String add() {
        return prefix + "/SXsglMdlsrbbYgSalesperformanceinfoAdd";
    }

    /**
    * 零售员工日报表 新增
    *
    * @return
    */
    @Log(title = "零售员工日报表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sXsglMdlsrbbYgSalesperformanceinfoAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sXsglMdlsrbbYgSalesperformanceinfoService.addSXsglMdlsrbbYgSalesperformanceinfo(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 零售员工日报表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("xsgl:xs:view")
    @GetMapping("/sXsglMdlsrbbYgSalesperformanceinfoView")
    public String sxsglmdlsrbbygsalesperformanceinfoListView() {
        return prefix + "/SXsglMdlsrbbYgSalesperformanceinfoList";
    }

    /**
    * 零售员工日报表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:sXsglMdlsrbbYgSalesperformanceinfoList")
    @PostMapping("/sXsglMdlsrbbYgSalesperformanceinfoList")
    @ResponseBody
    public TableDataInfo sxsglmdlsrbbygsalesperformanceinfoList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sXsglMdlsrbbYgSalesperformanceinfoService.findSXsglMdlsrbbYgSalesperformanceinfoList(pd);
        return getDataTable(pageData);
    }

    /**
    * 零售员工日报表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:remove")
    @Log(title = "零售员工日报表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sXsglMdlsrbbYgSalesperformanceinfoRemove")
    @ResponseBody
    public AjaxResult sxsglmdlsrbbygsalesperformanceinfoRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sXsglMdlsrbbYgSalesperformanceinfoService.SXsglMdlsrbbYgSalesperformanceinfoRemove(pd);
        return toAjax(integer);
    }

    /**
    * 零售员工日报表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:edit")
    @GetMapping("/sXsglMdlsrbbYgSalesperformanceinfoEdit/{id}")
    public String sxsglmdlsrbbygsalesperformanceinfoView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sXsglMdlsrbbYgSalesperformanceinfoService.findSXsglMdlsrbbYgSalesperformanceinfoList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/sxsglmdlsrbbygsalesperformanceinfoPageEdit";
        }
        return prefix+ "/sxsglmdlsrbbygsalesperformanceinfoEdit";
    }

    /**
    * 零售员工日报表保存修改的数据
    */
    @RequiresPermissions("xsgl:xs:edit")
    @Log(title = "零售员工日报表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sXsglMdlsrbbYgSalesperformanceinfoEdit")
    @ResponseBody
    public AjaxResult sxsglmdlsrbbygsalesperformanceinfoEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sXsglMdlsrbbYgSalesperformanceinfoService.updateSXsglMdlsrbbYgSalesperformanceinfo(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表sxsglmdlsrbbygsalesperformanceinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表sxsglmdlsrbbygsalesperformanceinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
